<?php defined('_JEXEC') or die( 'Restricted access' );

/**
 * @version 2.0 $Id: webcomments.php,v 1.6 2009/12/16 20:45:08 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport('joomla.application.component.model');

class LinkDirectory2ModelWebcomments extends JModel {

	private $_data = null;
	private $_total = null;
	private $_pagination = null;

	function __construct() {
		parent::__construct();
		global $mainframe, $option;		
		$limit		= $mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int' );
		$limitstart	= $mainframe->getUserStateFromRequest( $option.'.comments.limitstart', 'limitstart', 0, 'int' );
		$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
		$this->setState('limit', $limit);
		$this->setState('limitstart', $limitstart);
	}

	/**
	 *
	 */	
	public function &getData() {
		if (empty($this->_data)) {
			$query = $this->_buildQuery();
			$this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_data;
	}

	/**
	 *
	 */
	function getTotal() {
		if (empty($this->_total)) {
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}
		return $this->_total;
	}

	/**
	 *
	 */
	function &getPagination() {
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$total = $this->getTotal();
			$limitstart = $this->getState('limitstart');
			$limit = $this->getState('limit');
			if ($limitstart > $total) {
				$limitstart = (int)(ceil($total / $limit) - 1) * $limit;
			}
			$this->_pagination = new JPagination( $total, $limitstart , $limit );
		}
		return $this->_pagination;
	}

	private function _buildQuery() {
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		$query = ' SELECT a.*, l.title as link_title , u.name AS username '
			. ' FROM #__ldcomment AS a '
			. ' LEFT JOIN #__ldlinks AS l ON l.id = a.link_id '
			. ' LEFT JOIN #__users AS u on u.id = a.user_id '
			. $where
			. $orderby
		;
		return $query;
	}

	private function _buildContentOrderBy() {
		global $mainframe, $option;

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'comments.filter_order',		'filter_order',		'a.rev_date',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'comments.filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		if ($filter_order == 'a.rev_date'){
			$orderby 	= ' ORDER BY a.rev_date '.$filter_order_Dir;
		} else {
			$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir;
		}
		return $orderby;
	}

	private function _buildContentWhere() {
		global $mainframe, $option;
		$db					=& JFactory::getDBO();
		$filter_state		= $mainframe->getUserStateFromRequest( $option.'comments.filter_state',	'filter_state',	'',	'word' );
		$filter_type		= $mainframe->getUserStateFromRequest( $option.'comments.filter_type', 'filter_type', -1, 'int' );
		$search				= $mainframe->getUserStateFromRequest( $option.'comments.search','search', '',	'string' );
		$search				= JString::strtolower( $search );
		$where = array();
		if ($filter_type >= 0) {
			$where[] = 'a.type = '.(int) $filter_type;
		}
		if ($search) {
			$searchText = $db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			$where[] = '( LOWER(a.rev_title) LIKE '. $searchText . ' OR LOWER(a.rev_text) LIKE '. $searchText . ')';
		}
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where[] = 'a.rev_approved = 1';
			} else if ($filter_state == 'U' ) {
				$where[] = 'a.rev_approved = 0';
			}
		}
		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );
		return $where;
	}
}