<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: webcomment.php,v 1.3 2009/11/21 22:46:01 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
class TableWebcomment extends JTable {
	public $rev_id = null;
	public $link_id = null;
	public $user_id = null;
	public $type = null;
	public $guest_name = null;
	public $rev_title = null;
	public $rev_text = null;
	public $rev_date = null;
	public $rev_approved = null;
	public $published = null;
	public $checked_out = null;
	public $checked_out_time = null;

	public function __construct(&$db) {
		parent::__construct( '#__ldcomment', 'rev_id', $db );
	}
	
	public function check(){
		if (trim($this->rev_title) == '') {
			$this->setError(JText::_('WEBCOMMENT ITEM MUST HAVE A TITLE'));
			return false;
		}
		if (trim($this->rev_text) == '') {
			$this->setError(JText::_('WEBCOMMENT ITEM MUST HAVE A TEXT'));
			return false;
		}
		if ( ($this->user_id < 1 ) && trim ($this->guest_name) == '' ) {
			$this->setError(JText::_('WEBCOMMENT ITEM MUST HAVE A GUEST NAME'));
			return false;
		}
		if ( ($this->user_id > 0 ) && ( $this->guest_name) != '' ) {
			$this->setError(JText::_('WEBCOMMENT ITEM MUST NOT HAVE A GUEST NAME'));
			return false;
		}
		return true;
	}
	
	public function bind($array, $ignore = '') {
		$result = parent::bind($array, $ignore);
		if ($result = false) return false;
		$this->fixBindForNewItem();
		return true;
	}
	
	private function fixBindForNewItem(){
		if ($this->rev_id == 0){
			$user 	=& JFactory::getUser();
			$this->user_id = $user->id;
		}
		if (!$this->rev_date){
			$this->rev_date = gmdate('Y-m-d H:i:s');
		}	
	}
}
?>