<?php defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * @version 2.0 $Id: view.html.php,v 1.29 2009/12/01 19:59:52 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport( 'joomla.application.component.view');

require_once JPATH_COMPONENT.DS.'models'.DS.'categories.php';

class LinkDirectory2ViewLink extends JView {

	function display($tpl = null) {
	
		$document =& JFactory::getDocument();
		$task = JRequest::getVar('task');
		$row = $this->get( 'data' );

		$document->addStyleSheet('components'.DS.'com_linkdirectory2'.DS.'css'.DS.'linkdirectory.css');
		$this->addTemplatePath(JPATH_COMPONENT.DS.'views'.DS.'categories'.DS.'tmpl');
		$this->addTemplatePath(JPATH_COMPONENT.DS.'views'.DS.'link'.DS.'tmpl');

		$this->displayHead($row);
		$this->displaySearch();
		
		if (!$row->published){
			JError::raiseWarning(404,'CAN NOT FOUND WEBLINK');
			parent::display('notfound');
			return;
		}
		
		if (! $row->id ){
			JError::raiseWarning(404,'CAN NOT FOUND WEBLINK');
			parent::display('notfound');
			return;
		}
		
		if ( ($row->catid != 0 ) &&  ( $row->cat_published != 1 ) ) {
				JError::raiseWarning(404,'CAN NOT FOUND WEBLINK');
				parent::display('notfound');
				return;
		}

		// TODO ACCESS auf Kategorie wieder einbauen
		/*
		$user 	=& JFactory::getUser();
		if ($row->cat_access > $user->get('aid', 0)) {
				JError::raiseWarning( 403, JText::_('LD NO AUTHORIZATION') );
				return;
		}
		*/
	
		require_once JPATH_COMPONENT.DS.'classes'.DS.'ViewUtils.php';
		ViewUtils::setPageTitleForLink($row);
		switch ($task) {
			case 'view':
				$model=$this->getModel();
				$model->increaseHitCounter($row->id);
				$app = &JFactory::getApplication();
				$app->redirect($row->url, '');
				return;
			default:
				break;
			
		}
		
		
		$this->assignRef( 'row',	$row );
		
		require_once(JPATH_COMPONENT.DS.'classes'.DS.'ThumbnailUtils.php');
		$ldThumbnailService = new ThumbnailUtils();
		$linkThumbImage = $ldThumbnailService->getThumbForLink($row->url,$row->title,$row->id);
		if ($ldThumbnailService->isLinkThumbEnable()) { 
			$thumbnailServiceBackLink = $ldThumbnailService->getBackLinkForLinkThumb(); 
		}
		$this->assignRef('linkThumbImage',$linkThumbImage);
		$this->assignRef('thumbnailServiceBackLink',$thumbnailServiceBackLink);
		require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';
		$ld = new LDConfig();
		$this->assign( 'ratelink',$ld->ratelink);
		$this->assign( 'commentlink',$ld->commentlink);
		$this->assign( 'showhits',$ld->showhits);
		$this->assign( 'badlink',$ld->badlink);
		$this->assign( 'ldshowlinkadd',$ld->ldshowlinkadd);
		require_once(JPATH_COMPONENT.DS.'classes'.DS.'LinkdirectoryURL.php');
		$this->assignRef('rateurl',LinkdirectoryURL::getItemUrl('link','rate',$row->id));
		$this->assignRef('commenturl',LinkdirectoryURL::getItemUrl('link','comment',$row->id));
		$this->assignRef('cancelurl',LinkdirectoryURL::getItemUrl('link',null,$row->id));
		$this->assignRef('reporturl',LinkdirectoryURL::getItemUrl('link','report',$row->id));
		$this->assign('commentSystem',$ld->commentSystem);
		$this->assignRef('linkurl',LinkdirectoryURL::getUrlToLink($this->row->url,$this->row->id));
		$this->assign('javascriptchecks',$ld->javascriptchecks);
		parent::display();

		require_once JPATH_COMPONENT.DS.'classes'.DS.'ConfUtils.php';
		$confUtils = new ConfUtils();
		
		switch  ($task){
			case 'rate':
				break;				
			case 'report':
				break;
			default:
				jimport( 'joomla.application.component.helper' );
				switch ($confUtils->getCommentSystemType()){
					case 'jcomment':
						require_once JPATH_COMPONENT.DS.'classes'.DS.'CommentHtmlUtils.php';
						if (CommentHtmlUtils::isJCommentUseable()){
							parent::display('jcomments');
						}
						break;
					case 'intern':
						$document->addStyleSheet('components'.DS.'com_linkdirectory2'.DS.'css'.DS.'comment.css');
						$comments = $this->get( 'commentsData');
						$paginationComments = $this->get( 'paginationComments');
						$this->assignRef('comments',$comments);
						$this->assignRef('paginationComments',$paginationComments);
						$this->assign('viewRealnameInComment',$ld->realnamecomment);
						parent::display('comments');
						break;
					default:
						break;
				}
				break;
		}


		switch  ($task){
			case 'rate':
				parent::display('addrate');
				break;				
			case 'report':
				$this->assign('reportBadLink',true);
			case 'comment':
				$user = JFactory::getUser();
				$comment = & JTable::getInstance('ldcomment','Table');
				$comment->bind(JRequest::get('post'));
				$this->assign('option','com_linkdirectory2');
				$this->assignRef('comment',$comment);
				$this->assignRef('user',$user);
				require_once JPATH_COMPONENT.DS.'classes'.DS.'CommentHtmlUtils.php';
				$reportBadLinkOptionList = CommentHtmlUtils::getReportBadLinksOptionList($comment->type);
				$this->assignRef('report_type_list',$reportBadLinkOptionList);				
				parent::display('addcomment');
				break;
			default:
				break;
		}
	}
	
	
	private function displayHead(&$row){
		global $mainframe;
		require_once(JPATH_COMPONENT.DS.'classes'.DS.'ViewUtils.php');
		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();
		$params = &$mainframe->getParams();
		$this->assignRef('params',$params);
		
		$catModel=$this->setModel(new LinkDirectory2ModelCategories());
		$this->assign('ldPathWay',$catModel->getLDPathWay($row->catid,ViewUtils::getRootElementLabel()));
		
		parent::display('head');
	}
	
	private function displaySearch(){
		require_once JPATH_COMPONENT.DS.'classes'.DS.'ConfUtils.php';
		$confUtils = new ConfUtils();
		$this->assign('searchEnable',$confUtils->isSearchEnable());
		$this->assign('linkSearchEnable',$confUtils->isLinkSearchEnable());
		$this->assign('isCategorySearchEnable',$confUtils->isCategorySearchEnable());
		require_once JPATH_COMPONENT.DS.'classes'.DS.'SearchUtils.php';	
		SearchUtils::setSearchParameterIntoView($this);
		parent::display('search');
	}
}
?>
