<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: view.html.php,v 1.7 2009/12/01 20:00:32 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport( 'joomla.application.component.view');

require_once JPATH_COMPONENT.DS.'models'.DS.'categories.php';

class LinkDirectory2ViewSearch extends JView {

	private function addStyleSheet(){
		$document 	= & JFactory::getDocument();
		$document->addStyleSheet('components'.DS.'com_linkdirectory2'.DS.'css'.DS.'linkdirectory.css');
	}
	
	private function getPathWay(){
		require_once JPATH_COMPONENT.DS.'classes'.DS.'ViewUtils.php';
		$model =& JModel::getInstance('categories', 'LinkDirectory2Model');
		return $model->getLDPathWay(null,ViewUtils::getRootElementLabel());
	}
	
	public function display($tpl = null) {			
		$this->addStyleSheet();
		$this->addTemplatePath(JPATH_COMPONENT.DS.'views'.DS.'categories'.DS.'tmpl');
		
		require_once JPATH_COMPONENT.DS.'classes'.DS.'ViewUtils.php';
		require_once JPATH_COMPONENT.DS.'classes'.DS.'SearchUtils.php';	
		require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';
		require_once JPATH_COMPONENT.DS.'classes'.DS.'ConfUtils.php';
		
		$model = SearchUtils::getSearchModel(SearchUtils::getSearchType());
		
		$rowsOfSearchResult=$model->getSearchResult();
		$searchtext=$model->getSearchText();
		$params=ViewUtils::setPageTitleForCategories($parentCategoryTitle);
		SearchUtils::setSearchParameterIntoView($this);
		$ldPathWay=$this->getPathWay();

		$ld = new LDConfig();
		$confUtils = new ConfUtils();
		
		$this->assign('tabclass', array( 'link1', 'link2' ));
		$this->assignRef('rows_of_links',$rows_of_links);
		$this->assign('searchtext',$searchtext);
		$this->assign('needDetailPage',$confUtils->needDetailPage());
		$this->assign('ratelink',$ld->ratelink);
		$this->assign('commentlink',$ld->commentlink);
		$this->assign('showhits',$ld->showhits);
		$this->assign('ldshowlinkadd',$ld->ldshowlinkadd);
		$this->assign('column',	$ld->column );
		$this->assign('showfastlink', $ld->showfastlink);
		$this->assignRef('params',$params);
		$this->assignRef('ldPathWay',$ldPathWay);
		
		
		parent::display('search');
		parent::display('head');
		
		$pageNavigation=$model->getPageNavigation();
		$found = count($rowsOfSearchResult)>0 ? true: false;
		if ($found){
			$this->assign('found',$found);
			switch (SearchUtils::getSearchType()){
				case 'links':
					$this->assignRef('rows_of_links',$rowsOfSearchResult);
					$this->assignRef('paginationLinks',$pageNavigation);
					break;
				case 'categories':
					$this->assignRef('rows_of_categories',$rowsOfSearchResult);
					$this->assignRef('paginationLinks',$pageNavigation);
					break;
				default:
					parent::display('notfound');
					return;		
			}
			parent::display(SearchUtils::getSearchResultTemplate(SearchUtils::getSearchType()));
		} else {
			parent::display('notfound');		
		}
	}
}
?>
